unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, diocp_coder_tcpClient,
  utils_safeLogger,  uDIOCPDxStreamCoder, diocp_task, diocp_sockets,
   diocp_tcp_client, ExtCtrls,  SimpleMsgPack;

type
  TfrmMain = class(TForm)
    mmoRecvMessage: TMemo;
    btnConnect: TButton;
    edtHost: TEdit;
    edtPort: TEdit;
    pnlOperator: TPanel;
    pnlSendArea: TPanel;
    btnSendObject: TButton;
    mmoData: TMemo;
    btnLogin: TButton;
    cbbName: TComboBox;
    lstUsers: TListBox;
    tmrHeart: TTimer;
    Button2: TButton;
    btn1: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure btnLoginClick(Sender: TObject);
    procedure btnSendObjectClick(Sender: TObject);
    procedure tmrHeartTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn1Click(Sender: TObject);
  private
    FUserID:String;

    FCMDObject: TSimpleMsgPack;
    FCMDStream: TMemoryStream;

    FDiocpContext: TIocpCoderRemoteContext;

    FCoderTcpClient: TDiocpCoderTcpClient;

    procedure OnRecvObject(pvObject:TObject);

    procedure OnDisconnected(pvContext: TDiocpCustomContext);

    procedure DoHeart;

    procedure SendCMDObject(pvCMDObject: TSimpleMsgPack);

    procedure StartHeart();
    procedure UpdataUser;
  public

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  frmMain: TfrmMain;

implementation


{$R *.dfm}

{ TfrmMain }

constructor TfrmMain.Create(AOwner: TComponent);
begin
  inherited;
  sfLogger.setAppender(TStringsAppender.Create(mmoRecvMessage.Lines));
  sfLogger.AppendInMainThread := true;
  FCoderTcpClient := TDiocpCoderTcpClient.Create(Self);
  FDiocpContext :=TIocpCoderRemoteContext(FCoderTcpClient.Add);

  FDiocpContext.RegisterCoderClass(TIOCPStreamDecoder, TIOCPStreamEncoder);
  FDiocpContext.OnContextAction := OnRecvObject;
  FCoderTcpClient.OnContextDisconnected := OnDisconnected;


  FCMDObject := TSimpleMsgPack.Create();
  FCMDStream := TMemoryStream.Create;
end;

destructor TfrmMain.Destroy;
begin
  FreeAndNil(FCMDObject);
  sfLogger.Enable := false;
  FCoderTcpClient.DisconnectAll;
  FCoderTcpClient.Free;
  FCMDStream.Free;
  inherited Destroy;
end;

procedure TfrmMain.DoHeart;
begin
  FCMDObject.Clear;
  FCMDObject.ForcePathObject('cmdIndex').AsInteger := 0;
  SendCMDObject(FCMDObject);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FCoderTcpClient.DisconnectAll;
end;

procedure TfrmMain.btn1Click(Sender: TObject);
begin
 FCoderTcpClient.DisconnectAll;
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  FCoderTcpClient.open;

  if FDiocpContext.Active then
  begin
    sfLogger.logMessage('Ѿӵ');
    Exit;
  end;
  FDiocpContext.Host := edtHost.Text;
  FDiocpContext.Port := StrToInt(edtPort.Text);
  FDiocpContext.Connect;

  sfLogger.logMessage('ӳɹ, е½');
  
end;

procedure TfrmMain.btnLoginClick(Sender: TObject);
begin
  FCMDObject.Clear;
  FCMDObject.ForcePathObject('cmdIndex').AsInteger := 11;
  FCMDObject.ForcePathObject('requestID').AsString := 'login';
  FCMDObject.ForcePathObject('params.userid').AsString := cbbName.Text;
  SendCMDObject(FCMDObject);


end;

procedure TfrmMain.btnSendObjectClick(Sender: TObject);
begin
  FCMDObject.Clear;
  FCMDObject.ForcePathObject('cmdIndex').AsInteger := 5;
  FCMDObject.ForcePathObject('requestID').AsString := 'messageID';
  FCMDObject.ForcePathObject('params.msg').AsString := mmoData.Lines.Text;
  SendCMDObject(FCMDObject);
end;
// :
///   {
/// 	   "cmdIndex": 3,
/// 	   "requestID":"xxx-xx-xx-xx",  // ID, ظַӦʱ, ȥ
/// 	   "params":
/// 	    {
/// 		    "page":1,               // ѯҳ(ʾڼҳ)
/// 		  }
/// 	}
///
procedure TfrmMain.Button1Click(Sender: TObject);
begin
  FCMDObject.Clear;
  FCMDObject.ForcePathObject('cmdIndex').AsInteger := 3;
  FCMDObject.ForcePathObject('requestID').AsString := cbbName.Text;
  FCMDObject.ForcePathObject('params.page').AsString :='1';
  SendCMDObject(FCMDObject);
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  FCMDObject.ForcePathObject('cmdIndex').AsInteger := 5;
 // FCMDObject.ForcePathObject('userid').AsString := cbbName.Text;
  FCMDObject.ForcePathObject('params.userid').AsString := lstUsers.Items[lstUsers.ItemIndex];
  FCMDObject.ForcePathObject('params.msg').AsString := mmoData.Lines.Text;
  SendCMDObject(FCMDObject);
end;

procedure TfrmMain.OnDisconnected(pvContext: TDiocpCustomContext);
begin
  if csDestroying in ComponentState then
  begin
    exit;
  end;

  sfLogger.logMessage('Ͽ...');
end;

procedure TfrmMain.OnRecvObject(pvObject: TObject);
var
  s:AnsiString;
  lvStream:TMemoryStream;
  lvCMDObject:TSimpleMsgPack;
  lvItem, lvList:TSimpleMsgPack;
  UserNum,I:Integer;
begin
  lvStream := TMemoryStream(pvObject);
  lvCMDObject:= TSimpleMsgPack.Create;
  try
    lvCMDObject.DecodeFromStream(lvStream);

    // 쳣Ϣ
    if lvCMDObject.ForcePathObject('result.code').AsInteger = -1 then
    begin
      sfLogger.logMessage(lvCMDObject.ForcePathObject('result.msg').AsString);
    end;

    if lvCMDObject.ForcePathObject('requestID').AsString = 'login' then
    begin
      UpdataUser;
      if lvCMDObject.ForcePathObject('result.code').AsInteger = 0 then
      begin
        sfLogger.logMessage('½ɹ...');
        iocpTaskManager.PostATask(StartHeart, true);
      end;
    end else if lvCMDObject.ForcePathObject('cmdIndex').AsInteger = 21 then
    begin
       UpdataUser;
      if lvCMDObject.ForcePathObject('type').AsInteger = 0 then
      begin
        sfLogger.logMessage(Format('û[%s]Ѿ!', [lvCMDObject.ForcePathObject('userid').AsString]));
      end else
      begin
        sfLogger.logMessage(Format('û[%s]!', [lvCMDObject.ForcePathObject('userid').AsString]));
      end;
    end else if lvCMDObject.ForcePathObject('cmdIndex').AsInteger = 6 then
    begin
      sfLogger.logMessage(Format('û[%s]˽Ķ˵:%s',[lvCMDObject.ForcePathObject('userid').AsString, lvCMDObject.ForcePathObject('msg').AsString]));
    end else if lvCMDObject.ForcePathObject('cmdIndex').AsInteger = 5 then
    begin
      if lvCMDObject.ForcePathObject('result.code').AsInteger = 0 then
      begin
        sfLogger.logMessage(Format('˵:%s',
          [lvCMDObject.ForcePathObject('params.msg').AsString]));
      end;       
    end else if lvCMDObject.ForcePathObject('cmdIndex').AsInteger = 3 then
    begin
      if lvCMDObject.ForcePathObject('result.code').AsInteger = 0 then
      begin
          UserNum:=lvCMDObject.ForcePathObject('list').Count;
          for I := 0 to UserNum-1 do
          begin
          lstUsers.Clear;
          lstUsers.Items.Add(lvCMDObject.ForcePathObject('list').Items[i].ForcePathObject('userid').AsString);
          end;
//         ShowMessage(lvCMDObject.ForcePathObject('list').Items[0].ForcePathObject('userid').AsString);
//         ShowMessage(lvCMDObject.ForcePathObject('list').Items[1].ForcePathObject('userid').AsString);
      end;
    end else if lvCMDObject.ForcePathObject('cmdIndex').AsInteger = 6 then
    begin
      if lvCMDObject.ForcePathObject('result.code').AsInteger = 0 then
      begin
         mmoData.Lines.Add(lvCMDObject.ForcePathObject('userid').AsString+'˵'+

                lvCMDObject.ForcePathObject('msg').AsString );
//         ShowMessage(lvCMDObject.ForcePathObject('list').Items[0].ForcePathObject('userid').AsString);
//         ShowMessage(lvCMDObject.ForcePathObject('list').Items[1].ForcePathObject('userid').AsString);
      end;
    end;
  finally
    lvCMDObject.Free;
  end;


  


 end;

procedure TfrmMain.SendCMDObject(pvCMDObject: TSimpleMsgPack);
var
  lvCMDStream:TMemoryStream;
begin
  lvCMDStream := TMemoryStream.Create;
  try
    pvCMDObject.EncodeToStream(lvCMDStream);
    FDiocpContext.WriteObject(lvCMDStream);
  finally
    lvCMDStream.Free;
  end;
end;

procedure TfrmMain.StartHeart;
begin
  tmrHeart.Enabled := true;
end;

procedure TfrmMain.tmrHeartTimer(Sender: TObject);
begin
  DoHeart;
end;

procedure TfrmMain.UpdataUser; //б
begin
        FCMDObject.Clear;
        FCMDObject.ForcePathObject('cmdIndex').AsInteger := 3;
        FCMDObject.ForcePathObject('requestID').AsString := cbbName.Text;
        FCMDObject.ForcePathObject('params.page').AsString :='1';
        SendCMDObject(FCMDObject);
end;

end.
